<?php
/*

PHP

RSS-parser v0.1-2022.06.10

Генерація стрічки новин. Тестова сторінка без кешу.
На виході - стрічка новин з вбудованим CSS і форматуванням.

Головна ціль - доставка легкого текстового контенту.

Перевіряється існування джерела новин, граббиться фавікон,
встановлюється кількість записів для відображення, та фільтруються
зайві стилі і помилки у фідах (підбирається в залежності від джерела).

*/

	// Вказуємо адресу стрічки RSS
	$URL = "https://chtyvo.org.ua/feed/bookshq.rss";
	// $URL = "https://suspilne.media/rss/ukrnet.rss";
	// $URL = "https://espreso.tv/rss";

	// Форматуємо поточну дату. Дивись http://userguide.icu-project.org/formatparse/datetime
	$fmt = new IntlDateFormatter(
		'uk_Uk',
		IntlDateFormatter::FULL,
		IntlDateFormatter::FULL,
		'Europe/Kiev',
		IntlDateFormatter::GREGORIAN,
		'd MMMM, Y року'
	);
	$today = "Сьогодні ".$fmt->format(time());
?>
<!DOCTYPE HTML>
<html lang="uk">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>RSS | Home</title>
		<meta name="description" content="Електронний архів документів і тестувальний майданчик для приватного користування.">
		<link rel="shortcut icon" href="favicon.png" type="image/x-icon">
	</head>
	<body style="font-family: Trebuchet MS;">
		<div style='padding: 20px 40px 20px 40px; color: DimGrey'>	
<?php
		// Перевірка існування файла з інформацією
		$url = $URL;
		$urlHeaders = @get_headers($url);
		
		// Якщо відповідь сервера на наявність коду: 200 - ОК
		if(strpos($urlHeaders[0], '200')) {
    		// Отримаємо favicon з сайта і формуємо шапку
			$favikon = "http://www.google.com/s2/favicons?domain=".$URL;
			echo $free = "			<div style='padding: 20px 0 20px 0; color: DimGrey'><div style='display:inline; float:left;'><img src='".$favikon."'></div><div style='display:inline; float:right;'>$today</div></div>";
			
			// Читаємо контент фіду
			$content = file_get_contents($URL);

			// Вказуємо кількість новин для виводу на сторінку
			$NUMITEMS = 15;
			$count = 0;
			 
			// Отримуємо XML стрічки з указаної адреси
			$element = new SimpleXMLElement($content);

			echo "<table style='border: 1px white; border-spacing: 0 10px;'>";

			foreach($element->channel->item as $entry) {
				$date = new DateTime($entry->pubDate);
				$date = $date->format('Y-m-d H:i');
				
				// Змінні для виводу на сторінку
				$title = $entry->title;
				$link = $entry->link;
				$description = $entry->description;
				$fulltext = $entry->fulltext;

				// Фільтруємо сміття (цю частину треба доробити. Незакінчено.)
				$patterns = array();
				$patterns[0] = '|(&amp;)|Uis';
				$patterns[1] = '|(&nbsp;)|Uis';
				$patterns[2] = '|(	)|Uis'; // видаляємо	'tab'
				$patterns[3] = '|(  )|Uis'; // видаляємо 'подвійний пробіл'
				$patterns[4] = '|(<br />)|Uis';
				$patterns[5] = '|( />)|Uis';
				$patterns[6] = '|( style=").*(")|Uis';
				$patterns[7] = '|(<p> )|Uis';
				$patterns[8] = '|(<p></p>)|Uis';
				$patterns[9] = '|(Додано твір <a).*(</a>)|Uis';
				$patterns[10] = '|(\(<a ).*(</a>\).)|Uis';
				$patterns[11] = '|(<img )|Uis';
				$patterns[12] = '|(\n)|Uis';	// стискаємо інформацію

				$replacements = array();
				$replacements[0] = '&';
				$replacements[1] = ' ';
				$replacements[2] = ' ';
				$replacements[3] = ' ';
				$replacements[4] = '<br>';
				$replacements[5] = '>';			
				$replacements[6] = '';
				$replacements[7] = '<p>';
				$replacements[8] = '';
				$replacements[9] = '';
				$replacements[10] = '';
				$replacements[11] = '<img width="200" style="float:left; padding-right:20px; padding-bottom:20px;"';
				$replacements[12] = '';
				
				$title = preg_replace($patterns, $replacements, $title);
				$description = preg_replace($patterns, $replacements, $description);
				$fulltext = preg_replace($patterns, $replacements, $fulltext);

				echo "<tr style='background:#FFFFE0'><td><div style='margin: 0px 60px 30px 60px;'><h4 style='color:tomato;'>$date</h4><h4><a style='text-decoration:none;' href=$link title='Перейти на сайт'>$title</a></h4>";
				echo "<p>$description</p>$fulltext</div></td></tr>";

				// Виходимо з циклу, коли досягнута вказана кількість новин
				if (++$count >= $NUMITEMS) break;
			}
			echo "</table>\n";
			
				// Якщо сайт недоступний, то виводимо повідомлення і припиняємо роботу скрипта
			} else {
				echo "<center><p>Стрічка новин поки недоступна з цього ресурсу.</p><p>Завітайте пізніше, будь ласка!</p></center>";
				exit;
			}
		?>
		</div>
	</body>
</html>